#include "testlib.h"
#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int main(int argc, char* argv[]){
	// accepts three arguments: 
	// 1. max value of n and q (value ends on 1 forces max test)
	// 2. max value of t_i for all i
	// 3. seed 
	registerGen(argc, argv, 1);
    int MAXNQ = opt<int>(1);
	int MAXT = opt<int>(2);
	int n = rnd.wnext(MAXNQ, log10(MAXNQ)) + 1;
	int q = rnd.wnext(MAXNQ, log10(MAXNQ)) + 1;
	if(MAXNQ % 10 == 1) n = q = MAXNQ - 1;
	vector<array<int, 3>> queries(q);
	for(int i = 0; i < q; i ++){
		int t = -1, l = -1, r = -1;
		if(i == 0){
			t = 1;
			l = rnd.next(1, n);
			r = rnd.next(1, n);
			if(r < l) swap(l, r);
		}
		else{
			t = rnd.next(1, MAXT);
			// biases longer intervals
			if(t == 1){
				bool is_big = rnd.next(0, 1);
				int len = -1;
				if(is_big) len = rnd.next(n / 2, n - 1);
				else len = rnd.next(1, n);
				assert(1 <= len && len <= n);
				r = rnd.next(len, n);
				l = r - len + 1;
			}
			if(t == 2){
				bool is_big = rnd.next(0, 1);
				int len = -1;
				if(is_big) len = rnd.next((i + 1) / 2, i);
				else len = rnd.next(1, i);
				r = rnd.next(len, i);
				l = r - len + 1;
			}
		}
		assert(t > 0 && l > 0 && r > 0);
		queries[i] = {t, l, r};
	}
	cout << n << " " << q << endl;
	assert(q == queries.size());
	int i = 1;
	for(auto [t, l, r] : queries){
		cout << t << " " << l << " " << r << endl;
		if(t == 1){
			assert(1 <= l);
			assert(l <= r);
			assert(r <= n);
		}
		if(t == 2){
			assert(1 <= l);
			assert(l <= r);
			assert(r <= i);
		}
		++ i;
	}
}
